package jp.hishidama.robot.ie;

import jp.hishidama.robot.TimeoutException;
import jp.hishidama.robot.win.FileSaveDialog;
import jp.hishidama.robot.win.YesNoDialog;

/**
 * IEt@C_E[hsNX.
 * <p>
 * IEgt@C̃_E[hsNXB
 * </p>
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/ierobot.html">Ђ</a>
 * @since 2007.11.01
 * @version 2007.11.06
 */
public class FileDownloadRobot {

	/** t@CFJ */
	public static final int CONFIRM_OPEN = 0;

	/** t@CFۑ */
	public static final int CONFIRM_SAVE = 1;

	/** t@CFLZ */
	public static final int CONFIRM_CANCEL = 2;

	/**
	 * ^CAEgF_E[hJn
	 * 
	 * @see #download(int, String, int)
	 * @see TimeoutException#getPos()
	 */
	public static final int POS_START = 0;

	/** ^CAEgFJ/ۑ̊mF */
	public static final int POS_CONFIRM = 1;

	/** ^CAEgFJ/ۑ̊mF */
	public static final int POS_CONFIRM_END = 2;

	/** ^CAEgFۑꏊ̊mF */
	public static final int POS_SAVE = 3;

	/** ^CAEgFۑꏊ̊mF */
	public static final int POS_SAVE_END = 4;

	/** ^CAEgF㏑mF */
	public static final int POS_OVERWRITE = 5;

	/** ^CAEgF㏑mF */
	public static final int POS_OVERWRITE_END = 6;

	/** ^CAEgFN[Y */
	public static final int POS_CLOSE = 7;

	protected FileDownloadProgressDialog pd;

	/**
	 * RXgN^[
	 * 
	 * @param pd
	 *            Ώۂ́ut@C̃_E[hv_CAO
	 */
	public FileDownloadRobot(FileDownloadProgressDialog pd) {
		this.pd = pd;
	}

	protected int pos;

	/**
	 * _E[hs.
	 * 
	 * @param confirm
	 *            {@link #CONFIRM_SAVE}
	 * @param name
	 *            ۑꍇ̃t@CinullȂ ftHĝ܂܁j
	 * @param timeout
	 *            ^CAEgԁi0ƃ^CAEgȂj
	 * @exception TimeoutException
	 *                ^CAEgipos{@link #POS_START}j
	 */
	public void download(int confirm, String name, int timeout) {

		pos = POS_START;
		long start = System.currentTimeMillis();

		// _E[h_CAOLȊԁA
		while (pd.isWindow()) {
			try {
				// if (!pd.isCloseDownloaded()) {
				if (pd.isFileButtonEnabled() && pd.isFolderButtonEnabled()) {
					// ut@CJv{^ƁutH_[Jv{^LɂȂĂ
					// _E[h
					pd.clickCancelButton(); // uv{^iID̓LZ{^Ɠj
					pos = POS_CLOSE;
					while (pd.isWindow()) {
						long t = System.currentTimeMillis();
						if (timeout >= 0 && t - start > timeout) {
							throw new TimeoutException(pos, timeout);
						}
						pd.delay(100);
					}
					break;
				}
				// }
			} catch (TimeoutException e) {
				throw e;
			} catch (RuntimeException e) {
			}

			long t = System.currentTimeMillis();
			if (timeout >= 0 && t - start > timeout) {
				throw new TimeoutException(pos, timeout);
			}

			// Jۑ邩mF_CAO
			FileDownloadConfirmDialog cd = pd.getConfirmDialog();
			if (cd != null) {
				doConfirmDialog(cd, confirm, start, timeout);
			}

			// uOtĕۑv_CAO
			FileSaveDialog sd = pd.getSaveDialog();
			if (sd != null) {
				doSaveDialog(sd, name, start, timeout);
			}

			pd.delay(100);
		}
	}

	protected void doConfirmDialog(FileDownloadConfirmDialog cd, int confirm,
			long start, int timeout) {
		pos = POS_CONFIRM;
		while (cd.isWindow()) {
			cd.SetForegroundWindow();
			// cd.setFocus();

			long t = System.currentTimeMillis();
			if (timeout >= 0 && t - start > timeout) {
				throw new TimeoutException(pos, timeout);
			}

			switch (confirm) {
			case CONFIRM_OPEN:
				cd.clickOpenButton();
				break;
			case CONFIRM_SAVE:
				cd.clickSaveButton();
				break;
			case CONFIRM_CANCEL:
				cd.clickCancelButton();
				break;
			default:
				throw new IllegalArgumentException("confirm:" + confirm);
			}

			cd.delay(100);
		}
		pos = POS_CONFIRM_END;
	}

	protected void doSaveDialog(FileSaveDialog sd, String name, long start,
			int timeout) {
		pos = POS_SAVE;

		if (name != null) {
			sd.SetForegroundWindow();
			sd.delay(100);
			for (;;) {
				// ۑt@CύX
				sd.setName(name);
				sd.delay(100);

				String n = sd.getName();
				if (name.equals(n)) {
					break;
				}

				long t = System.currentTimeMillis();
				if (timeout >= 0 && t - start > timeout) {
					throw new TimeoutException(pos, timeout);
				}
			}
		}

		while (sd.isWindow()) {
			// sd.setFocus();
			sd.SetForegroundWindow();

			long t = System.currentTimeMillis();
			if (timeout >= 0 && t - start > timeout) {
				throw new TimeoutException(pos, timeout);
			}

			sd.clickSaveButton();

			// t@Cɑ݂ĂꍇAw㏑邩ǂmF_CAOxJ
			YesNoDialog yd = sd.getOverwirteDialog();
			if (yd != null) {
				pos = POS_OVERWRITE;
				while (yd.isWindow()) {
					t = System.currentTimeMillis();
					if (timeout >= 0 && t - start > timeout) {
						throw new TimeoutException(pos, timeout);
					}
					yd.clickYesButton();
					yd.delay(100);
				}
				pos = POS_OVERWRITE_END;

				while (sd.isWindow()) {
					t = System.currentTimeMillis();
					if (timeout >= 0 && t - start > timeout) {
						throw new TimeoutException(pos, timeout);
					}

					sd.delay(100);
				}
				break;

			} else {
				sd.delay(100);
			}
		}
		pos = POS_SAVE_END;
	}
}
