package jp.hishidama.win32.api;

import java.awt.Point;
import java.awt.Rectangle;
import java.util.List;

import jp.hishidama.win32.JWnd;

/**
 * winuser.h̊֐.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/hmwin32.html">Ђ</a>
 * @see JWnd
 * @since 2007.10.01
 * @version 2007.11.01
 */
public final class WinUser {

	static {
		System.loadLibrary("hmwin32");
	}

	private WinUser() {
	}

	/**
	 * bZ[WM.
	 * 
	 * @param hwnd
	 *            HWND
	 * @param msg
	 *            bZ[WiWM_*j
	 * @param wparam
	 *            WPARAM
	 * @param lparam
	 *            LPARAM
	 * @return bZ[WɂقȂ
	 */
	public static native int SendMessage(long hwnd, int msg, int wparam,
			int lparam);

	/**
	 * bZ[WM.
	 * 
	 * @param hwnd
	 *            HWND
	 * @param msg
	 *            bZ[WiWM_*j
	 * @param wparam
	 *            WPARAM
	 * @param lparam
	 *            LPARAMij
	 * @return bZ[WɂقȂ
	 */
	public static native int SendMessage(long hwnd, int msg, int wparam,
			String lparam);

	/**
	 * bZ[WM.
	 * 
	 * @param hwnd
	 *            HWND
	 * @param msg
	 *            bZ[WiWM_*j
	 * @param wparam
	 *            WPARAM
	 * @param lparam
	 *            LPARAMioCgzj
	 * @return bZ[WɂقȂ
	 */
	public static native int SendMessage(long hwnd, int msg, int wparam,
			byte[] lparam);

	/**
	 * bZ[WL[ւ̑M.
	 * 
	 * @param hwnd
	 *            HWND
	 * @param msg
	 *            bZ[WiWM_*j
	 * @param wparam
	 *            WPARAM
	 * @param lparam
	 *            LPARAM
	 * @return bZ[WɂقȂ
	 */
	public static native boolean PostMessage(long hwnd, int msg, int wparam,
			int lparam);

	/**
	 * EBhEݔf.
	 * 
	 * @param hwnd
	 *            HWND
	 * @return trueFEBhE݂ĂƂ
	 */
	public static native boolean IsWindow(long hwnd);

	/**
	 * qEBhEf.
	 * 
	 * @param hwndParent
	 *            eEBhEHWND
	 * @param hwnd
	 *            HWND
	 * @return trueFqEBhE邢͎qEBhÊƂ
	 */
	public static native boolean IsChild(long hwndParent, long hwnd);

	/**
	 * EBhE\Ԑݒ.
	 * 
	 * @param wnd
	 *            HWND
	 * @param cmdShow
	 *            \@i{@link WinUserConst#SW_HIDE}j
	 * @return trueFEBhEȑO\ĂƂ<br>
	 *         falseFEBhEȑO͔\Ƃ
	 */
	public static native boolean ShowWindow(long wnd, int cmdShow);

	/**
	 * EBhEړ.
	 * <p>
	 * EBhËʒuƃTCYύXB<br>
	 * gbvxEBhE̓XN[WAeEBhEEBhE̓NCAgWŎw肷B
	 * </p>
	 * 
	 * @param hwnd
	 *            HWND
	 * @param x
	 *            X
	 * @param y
	 *            Y
	 * @param width
	 *            
	 * @param height
	 *            
	 * @param repaint
	 *            ĕ`IvVitrueFEBhEWM_PAINTj
	 * @return trueF
	 * @throws Win32Exception
	 *             s
	 */
	public static native boolean MoveWindow(long hwnd, int x, int y, int width,
			int height, boolean repaint) throws Win32Exception;

	/**
	 * EBhEʒuݒ.
	 * <p>
	 * EBhËʒuETCYEZI[_[ύXB
	 * </p>
	 * 
	 * @param hwnd
	 *            HWND
	 * @param hWndInsertAfter
	 *            zuHWND
	 * @param x
	 *            X
	 * @param y
	 *            Y
	 * @param cx
	 *            
	 * @param cy
	 *            
	 * @param flags
	 *            EBhEʒuIvViSWP_*j
	 * @return trueF
	 * @throws Win32Exception
	 *             s
	 */
	public static native boolean SetWindowPos(long hwnd, long hWndInsertAfter,
			int x, int y, int cx, int cy, int flags) throws Win32Exception;

	/**
	 * \Ԕf.
	 * 
	 * @param wnd
	 *            HWND
	 * @return trueF\ĂiWS_VISIBLEX^CĂj
	 */
	public static native boolean IsWindowVisible(long wnd);

	/**
	 * ACRԔf.
	 * 
	 * @param wnd
	 *            HWND
	 * @return trueFŏiACRjĂ
	 */
	public static native boolean IsIconic(long wnd);

	/**
	 * ő剻Ԕf.
	 * 
	 * @param wnd
	 *            HWND
	 * @return trueFő剻Ă
	 */
	public static native boolean IsZoomed(long wnd);

	/**
	 * _CAO{bNXFRg[擾.
	 * 
	 * @param hdlg
	 *            HWND
	 * @param id
	 *            Rg[̎ʎq
	 * @return Rg[HWND
	 * @throws Win32Exception
	 *             s
	 */
	public static native long GetDlgItem(long hdlg, int id)
			throws Win32Exception;

	/**
	 * _CAO{bNXFRg[lݒ.
	 * 
	 * @param hdlg
	 *            HWND
	 * @param id
	 *            Rg[̎ʎq
	 * @param value
	 *            l
	 * @param signed
	 *            t邩ǂ
	 * @return ꍇAtrue
	 * @throws Win32Exception
	 *             s
	 */
	public static native boolean SetDlgItemInt(long hdlg, int id, int value,
			boolean signed) throws Win32Exception;

	/**
	 * _CAO{bNXFRg[l擾.
	 * 
	 * @param hdlg
	 *            HWND
	 * @param id
	 *            Rg[̎ʎq
	 * @param translated
	 *            0ԂɁAǂ̏ԂԂinull̏ꍇ͉ԂȂj
	 * @param signed
	 *            trueFtƂĈ
	 * @return l
	 * @throws Win32Exception
	 *             s
	 */
	public static native int GetDlgItemInt(long hdlg, int id,
			boolean[] translated, boolean signed) throws Win32Exception;

	/**
	 * _CAO{bNXFRg[eLXgݒ.
	 * 
	 * @param hdlg
	 *            HWND
	 * @param id
	 *            Rg[̎ʎq
	 * @param text
	 *            
	 * @return ꍇAtrue
	 * @throws Win32Exception
	 *             s
	 */
	public static native boolean SetDlgItemText(long hdlg, int id, String text)
			throws Win32Exception;

	/**
	 * _CAO{bNXFRg[eLXg擾.
	 * 
	 * @param hdlg
	 *            HWND
	 * @param id
	 *            Rg[̎ʎq
	 * @param len
	 *            ̍őTCY
	 * @return 
	 * @throws Win32Exception
	 *             s
	 */
	public static native String GetDlgItemText(long hdlg, int id, int len)
			throws Win32Exception;

	/**
	 * _CAO{bNXF`FbN{^ݒ.
	 * 
	 * @param hdlg
	 *            HWND
	 * @param nIDButton
	 *            Rg[̎ʎq
	 * @param uCheck
	 *            liBST_*j
	 * @return ꍇAtrue
	 * @throws Win32Exception
	 *             s
	 */
	public static native boolean CheckDlgButton(long hdlg, int nIDButton,
			int uCheck) throws Win32Exception;

	/**
	 * _CAO{bNXFWI{^ݒ.
	 * 
	 * @param hdlg
	 *            HWND
	 * @param nIDFirstButton
	 *            O[v̍ŏ̃{^̎ʎq
	 * @param nIDLastButton
	 *            O[v̍Ō̃{^̎ʎq
	 * @param nIDCheckButton
	 *            I{^̎ʎq
	 * @return ꍇAtrue
	 * @throws Win32Exception
	 *             s
	 */
	public static native boolean CheckRadioButton(long hdlg,
			int nIDFirstButton, int nIDLastButton, int nIDCheckButton)
			throws Win32Exception;

	/**
	 * _CAO{bNXF`FbN{^Ԏ擾.
	 * 
	 * @param hdlg
	 *            HWND
	 * @param nIDButton
	 *            {^̎ʎq
	 * @return {@link WinUserConst#BST_CHECKED}
	 */
	public static native int IsDlgButtonChecked(long hdlg, int nIDButton);

	/**
	 * _CAO{bNXFO[v̎Rg[擾.
	 * 
	 * @param hdlg
	 *            HWND
	 * @param hctl
	 *            Rg[HWND
	 * @param previous
	 *            tOitrueFÕRg[AfalseF̃Rg[j
	 * @return Rg[HWND
	 * @throws Win32Exception
	 *             s
	 */
	public static native long GetNextDlgGroupItem(long hdlg, long hctl,
			boolean previous) throws Win32Exception;

	/**
	 * _CAO{bNXF^uړ\ȎRg[擾.
	 * 
	 * @param hdlg
	 *            HWND
	 * @param hctl
	 *            Rg[HWND
	 * @param previous
	 *            tOitrueFÕRg[AfalseF̃Rg[j
	 * @return Rg[HWND
	 * @throws Win32Exception
	 *             s
	 */
	public static native long GetNextDlgTabItem(long hdlg, long hctl,
			boolean previous) throws Win32Exception;

	/**
	 * _CAO{bNXFRg[ʎq擾.
	 * 
	 * @param hctl
	 *            Rg[HWND
	 * @return Rg[̎ʎq
	 * @throws Win32Exception
	 *             s
	 */
	public static native int GetDlgCtrlID(long hctl) throws Win32Exception;

	/**
	 * L[{[htH[JXݒ.
	 * 
	 * @param wnd
	 *            HWND
	 * @return ȑOɃL[{[htH[JXĂEBhEHWND
	 * @throws Win32Exception
	 *             s
	 */
	public static native long SetFocus(long wnd) throws Win32Exception;

	/**
	 * L[{[htH[JXEBhE擾.
	 * 
	 * @return HWND L[{[htH[JXEBhEHWNDiYEBhEꍇA0j
	 * @see #GetForegroundWindow()
	 */
	public static native long GetFocus();

	/**
	 * ANeBuEBhEݒ.
	 * <p>
	 * EBhEANeBuɂB
	 * </p>
	 * 
	 * @param wnd
	 *            HWND
	 * @return ȑOANeBuEBhEHWND
	 * @throws Win32Exception
	 *             s
	 */
	public static native long SetActiveWindow(long wnd) throws Win32Exception;

	/**
	 * ANeBuEBhE擾.
	 * 
	 * @return HWND ANeBuȃEBhEHWNDiYEBhEȂꍇAnullj
	 * @see #GetForegroundWindow()
	 */
	public static native long GetActiveWindow();

	/**
	 * ͉ېݒ.
	 * <p>
	 * ɂƃ}EX͂L[{[h͂󂯕tȂBO[AEgԁH
	 * </p>
	 * 
	 * @param wnd
	 *            HWND
	 * @param enable
	 *            trueFLAfalseF
	 * @return trueFɖɂȂĂƂ
	 * @throws Win32Exception
	 *             s
	 */
	public static native boolean EnableWindow(long wnd, boolean enable)
			throws Win32Exception;

	/**
	 * ͉۔f.
	 * <p>
	 * }EX͂L[{[h͂󂯕tԁiO[AEgHjǂԂB
	 * </p>
	 * 
	 * @param wnd
	 *            HWND
	 * @return trueFLAfalseF
	 */
	public static native boolean IsWindowEnabled(long wnd);

	/**
	 * tHAOEhEBhEݒ.
	 * <p>
	 * EBhEtHAOEhiANeBujɂB
	 * </p>
	 * 
	 * @param wnd
	 *            HWND
	 * @return trueFtHAOEhɂȂ
	 */
	public static native boolean SetForegroundWindow(long wnd);

	/**
	 * tHAOEhEBhE擾.
	 * 
	 * @return HWND
	 */
	public static native long GetForegroundWindow();

	/**
	 * XN[o[\Ԑݒ.
	 * 
	 * @param wnd
	 *            HWND
	 * @param bar
	 *            ݒΏہiSB_*j
	 * @param show
	 *            trueF\AfalseF\
	 * @return trueF
	 * @throws Win32Exception
	 *             s
	 */
	public static native boolean ShowScrollBar(long wnd, int bar, boolean show)
			throws Win32Exception;

	/**
	 * XN[o[ېݒ.
	 * 
	 * @param wnd
	 *            HWND
	 * @param bar
	 *            ݒΏہiSB_*j
	 * @param arrows
	 *            ̗LݒiESB_*j
	 * @return trueF<br>
	 *         falseFɐݒ肳Ă
	 * @throws Win32Exception
	 *             s
	 */
	public static native boolean EnableScrollBar(long wnd, int bar, int arrows)
			throws Win32Exception;

	/**
	 * EBhEeLXgݒ.
	 * <p>
	 * EBhẼ^CgRg[̃eLXgύXB<br>
	 * AvP[ṼeLXg͕ύXłȂB
	 * </p>
	 * 
	 * @param wnd
	 *            HWND
	 * @param string
	 *            eLXg
	 * @return trueF
	 * @throws Win32Exception
	 *             s
	 */
	public static native boolean SetWindowText(long wnd, String string)
			throws Win32Exception;

	/**
	 * EBhEeLXg擾.
	 * <p>
	 * EBhẼ^CgRg[̃eLXg擾B
	 * </p>
	 * 
	 * @param wnd
	 *            HWND
	 * @return eLXg
	 * @throws Win32Exception
	 *             s
	 */
	public static native String getWindowText(long wnd) throws Win32Exception;

	/**
	 * EBhEeLXg擾.
	 * 
	 * @param wnd
	 *            HWND
	 * @return EBhEeLXg̕
	 * @throws Win32Exception
	 *             s
	 */
	public static native int GetWindowTextLength(long wnd)
			throws Win32Exception;

	/**
	 * NCAg̈擾.
	 * <p>
	 * NCAg̈NCAgWŕԂ̂ŁA͏(0,0)ƂȂB
	 * </p>
	 * 
	 * @param wnd
	 *            HWND
	 * @param r
	 *            WliNCAgWnj
	 * @return trueF
	 * @throws Win32Exception
	 *             s
	 */
	public static native boolean GetClientRect(long wnd, Rectangle r)
			throws Win32Exception;

	/**
	 * EBhË擾.
	 * 
	 * @param wnd
	 *            HWND
	 * @param r
	 *            WliXN[Wnj
	 * @return trueF
	 * @throws Win32Exception
	 *             s
	 */
	public static native boolean GetWindowRect(long wnd, Rectangle r)
			throws Win32Exception;

	/**
	 * bZ[W{bNX.
	 * 
	 * @param wnd
	 *            HWND
	 * @param text
	 *            eLXg
	 * @param caption
	 *            ^Cg
	 * @param type
	 *            X^Ci{@link WinUserConst#MB_OK}j
	 * @return ߂li{@link WinUserConst#IDOK}j
	 * @throws Win32Exception
	 *             s
	 */
	public static native int MessageBox(long wnd, String text, String caption,
			int type) throws Win32Exception;

	/**
	 * XN[Wϊ.
	 * 
	 * @param wnd
	 *            HWND
	 * @param point
	 *            NCAgWiXN[Wɕϊj
	 * @return trueF
	 * @throws Win32Exception
	 *             s
	 */
	public static native boolean ClientToScreen(long wnd, Point point)
			throws Win32Exception;

	/**
	 * NCAgWϊ.
	 * 
	 * @param wnd
	 *            HWND
	 * @param point
	 *            XN[WiNCAgWɕϊj
	 * @return trueF
	 * @throws Win32Exception
	 *             s
	 */
	public static native boolean ScreenToClient(long wnd, Point point)
			throws Win32Exception;

	/**
	 * wʒuEBhE擾.
	 * 
	 * @param x
	 *            X
	 * @param y
	 *            Y
	 * @return HWNDiEBhEꍇAnullj
	 * @see #ChildWindowFromPoint(long, int, int)
	 */
	public static native long WindowFromPoint(int x, int y);

	/**
	 * wʒuqEBhE擾.
	 * 
	 * @param x
	 *            XiNCAgWnj
	 * @param y
	 *            YiNCAgWnj
	 * @return HWNDiWeEBhE̊OɂꍇAnullj
	 * @see #ChildWindowFromPointEx(long, int, int, int)
	 */
	public static native long ChildWindowFromPoint(long hwnd, int x, int y);

	/**
	 * wʒuqEBhE擾.
	 * 
	 * @param x
	 *            XiNCAgWnj
	 * @param y
	 *            YiNCAgWnj
	 * @param flags
	 *            ΏۂIvViCWP_*j
	 * @return HWNDiWeEBhE̊Oɂꍇ⎸sꍇAnullj
	 */
	public static native long ChildWindowFromPointEx(long hwnd, int x, int y,
			int flags);

	/**
	 * EBhE擾.
	 * 
	 * @param hwnd
	 *            HWND
	 * @param index
	 *            ̃ItZbg
	 * @return i32bitj
	 * @throws Win32Exception
	 *             s
	 * @see #SetParent(long, long)
	 */
	public static native int GetWindowLong(long hwnd, int index)
			throws Win32Exception;

	/**
	 * EBhEݒ.
	 * 
	 * @param hwnd
	 *            HWND
	 * @param index
	 *            ̃ItZbg
	 * @param value
	 *            Vl
	 * @return ύXO̒l
	 * @throws Win32Exception
	 *             s
	 * @see #SetParent(long, long)
	 */
	public static native int SetWindowLong(long hwnd, int index, int value)
			throws Win32Exception;

	/**
	 * fXNgbv擾.
	 * 
	 * @return HWND
	 * @see #GetWindow(long, int)
	 */
	public static native long GetDesktopWindow();

	/**
	 * eEBhE擾.
	 * 
	 * @param wnd
	 *            HWND
	 * @return eEBhEi܂̓I[i[EBhEjHWND<br>
	 *         gbvxEBhȄꍇA0
	 * @throws Win32Exception
	 *             s
	 * @see #GetAncestor(long, int)
	 */
	public static native long GetParent(long wnd) throws Win32Exception;

	/**
	 * eEBhEݒ.
	 * 
	 * @param wnd
	 *            HWND
	 * @param wndParent
	 *            eEBhEinull̏ꍇAfXNgbvj
	 * @return O̐eEBhEHWND
	 * @throws Win32Exception
	 *             s
	 */
	public static native long SetParent(long wnd, long wndParent)
			throws Win32Exception;

	/**
	 * qEBhE.
	 * 
	 * @param hwnd
	 *            HWND
	 * @param list
	 *            qEBhEi{@link jp.hishidama.win32.JWnd}j
	 * @return trueF
	 * @throws Win32Exception
	 *             s
	 * @see #GetWindow(long, int)
	 */
	public static native boolean EnumChildWindows(long hwnd, List list)
			throws Win32Exception;

	/**
	 * gbvxEBhE.
	 * 
	 * @param list
	 *            EBhEi{@link jp.hishidama.win32.JWnd}j
	 * @return trueF
	 * @throws Win32Exception
	 *             s
	 * @see #GetWindow(long, int)
	 */
	public static native boolean EnumWindows(List list) throws Win32Exception;

	/**
	 * gbvxEBhE.
	 * 
	 * @param className
	 *            NX
	 * @param windowName
	 *            EBhE
	 * @return HWND
	 * @throws Win32Exception
	 *             s
	 * @see #getClassName(long)
	 * @see #getWindowText(long)
	 */
	public static native long FindWindow(String className, String windowName)
			throws Win32Exception;

	/**
	 * EBhENX擾.
	 * 
	 * @param hwnd
	 *            HWND
	 * @return NX
	 * @throws Win32Exception
	 *             s
	 */
	public static native String getClassName(long hwnd) throws Win32Exception;

	/**
	 * ԏ̎qEBhE擾.
	 * 
	 * @param hwnd
	 *            HWND
	 * @return HWNDiqEBhEȂꍇA0j
	 * @throws Win32Exception
	 *             s
	 */
	public static native long GetTopWindow(long hwnd) throws Win32Exception;

	/**
	 * EBhE擾.
	 * 
	 * @param hwnd
	 *            HWND
	 * @param cmd
	 *            iGW_HWNDNEXT ܂ GW_HWNDPREVj
	 * @return HWND
	 * @throws Win32Exception
	 *             s
	 */
	public static long GetNextWindow(long hwnd, int cmd) throws Win32Exception {
		return GetWindow(hwnd, cmd);
	}

	/**
	 * EBhE擾.
	 * 
	 * @param wnd
	 *            HWND
	 * @param cmd
	 *            ֌WiGW_*j
	 * @return HWND
	 * @throws Win32Exception
	 *             s
	 */
	public static native long GetWindow(long wnd, int cmd)
			throws Win32Exception;

	/**
	 * cEBhE擾.
	 * 
	 * @param wnd
	 *            HWND
	 * @param flags
	 *            p[^iGA_*j
	 * @return HWND
	 * @see #GetParent(long)
	 */
	public static native long GetAncestor(long wnd, int flags);
}
