package jp.hishidama.win32.com;

import java.lang.ref.ReferenceQueue;
import java.lang.ref.WeakReference;
import java.util.AbstractSequentialList;
import java.util.ConcurrentModificationException;
import java.util.Iterator;
import java.util.ListIterator;
import java.util.NoSuchElementException;

/**
 * QƃXg.
 * <p>
 * IuWFNg<a target="hishidama"
 * href="http://www.ne.jp/asahi/hishidama/home/tech/java/weak.html">Q</a>ێÃIuWFNgGCɂjꂽꍇɃXg폜B
 * </p>
 * <p>
 * {I{@link java.util.List ʏ̃Xg}Ɠl̎goBAnull鎖͏oȂB<br>
 * l擾ñ\bhł́A^C~OɂĂnullԂ邱ƂiGCɂjς݂ӖjB
 * </p>
 * <p>
 * NX̊{\̓NXgłACfbNXgđ삷郁\bh͊{IɎĂȂB<br>
 * NXMTZ[tł͂ȂB
 * </p>
 * <p><a target="hishidama"
 * href="http://www.ne.jp/asahi/hishidama/home/soft/java/util/weak.html">gp</a>
 * </p>
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/util/weak.html">Ђ</a>
 * 
 * @param ̃Xgێľ^
 * @see java.util.WeakHashMap
 * @see java.util.LinkedList
 * @since 2008.07.14
 */
class WeakList extends AbstractSequentialList {

	/** QƃL[ */
	private ReferenceQueue queue = new ReferenceQueue();

	/** EntrỹXg̐擪Ɩ\IuWFNg */
	private Entry root = new Entry();

	/** XgɕێĂ */
	private int size = 0;

	/** Xgɕێvfi΃bp[j */
	private class Entry extends WeakReference {

		private Entry prev, next;

		private Entry() {
			super(null, null);
			this.prev = this;
			this.next = this;
		}

		private Entry(Object referent, Entry next, Entry prev) {
			super(referent, queue);
			prev.next = this;
			this.prev = prev;
			this.next = next;
			next.prev = this;
		}

		private void remove() {
			prev.next = this.next;
			next.prev = this.prev;

			this.prev = null;
			this.next = null;
		}
	}

	private Entry addBefore(Object e, Entry entry) {
		Entry newEntry = new Entry(e, entry, entry.prev);
		size++;
		modCount++;
		return newEntry;
	}

	private Object remove(Entry e) {
		if (e == root) {
			throw new NoSuchElementException();
		}

		Object result = e.get();
		e.remove();
		size--;
		modCount++;
		return result;
	}

	private void expungeStaleEntries() {
		if (size == 0) {
			return;
		}
		for (;;) {
			Entry e = (Entry) queue.poll();
			if (e == null) {
				break;
			}
			remove(e);
		}
	}

	private Entry find(Object element) {
		for (Entry e = root.next; e != root; e = e.next) {
			if (element.equals(e.get()))
				return e;
		}
		return null;
	}

	/* private */Entry find(int index) {
		if (index < 0 || index >= size) {
			throw new IndexOutOfBoundsException("Index: " + index + ", Size: "
					+ size);
		}
		Entry e = root;
		if (index < size / 2) {
			for (int i = 0; i <= index; i++)
				e = e.next;
		} else {
			for (int i = size; i > index; i--)
				e = e.prev;
		}
		return e;
	}

	//
	//
	//

	/**
	 * Xg̐擪ɁAw肳ꂽvf}܂B
	 * 
	 * @param e
	 *            ǉvf
	 * @throws IllegalArgumentException
	 *             null̂Ƃ
	 */
	public void addFirst(Object e) {
		if (e == null) {
			throw new IllegalArgumentException();
		}
		expungeStaleEntries();
		addBefore(e, root.next);
	}

	/**
	 * Xg̍ŌɁAw肳ꂽvfǉ܂B
	 * 
	 * @param e
	 *            ǉvf
	 * @throws IllegalArgumentException
	 *             null̂Ƃ
	 */
	public void addLast(Object e) {
		if (e == null) {
			throw new IllegalArgumentException();
		}
		expungeStaleEntries();
		addBefore(e, root);
	}

	/**
	 * Xg̍ŏ̗vfԂ܂B
	 * 
	 * @return Xg̍ŏ̗vfiGCƂ̃^C~OɂĂnull̏ꍇj
	 * @throws NoSuchElementException
	 *             Xg̏ꍇ
	 */
	public Object getFirst() {
		expungeStaleEntries();
		if (size == 0) {
			throw new NoSuchElementException();
		}
		return root.next.get();
	}

	/**
	 * Xg̍Ō̗vfԂ܂B
	 * 
	 * @return Xg̍Ō̗vfiGCƂ̃^C~OɂĂnull̏ꍇj
	 * @throws NoSuchElementException
	 *             Xg̏ꍇ
	 */
	public Object getLast() {
		expungeStaleEntries();
		if (size == 0) {
			throw new NoSuchElementException();
		}
		return root.prev.get();
	}

	/**
	 * Xgŏ̗vf폜ĕԂ܂B
	 * 
	 * @return Xg̍ŏ̗vfiGCƂ̃^C~OɂĂnull̏ꍇj
	 * @throws NoSuchElementException
	 *             Xg̏ꍇ
	 */
	public Object removeFirst() {
		expungeStaleEntries();
		return remove(root.next);
	}

	/**
	 * XgŌ̗vf폜ĕԂ܂B
	 * 
	 * @return Xg̍Ō̗vfiGCƂ̃^C~OɂĂnull̏ꍇj
	 * @throws NoSuchElementException
	 *             Xg̏ꍇ
	 */
	public Object removeLast() {
		expungeStaleEntries();
		return remove(root.prev);
	}

	/**
	 * XgɎw肳ꂽvfꍇ true Ԃ܂B
	 * 
	 * @param o
	 *            Xgɂ邩ǂ𒲂ׂvf
	 */
	public boolean contains(Object o) {
		if (o == null) {
			return false;
		}
		expungeStaleEntries();
		return find(o) != null;
	}

	/**
	 * Xgɂvf̐Ԃ܂B
	 * 
	 * @return Xg̗vf
	 */
	public int size() {
		expungeStaleEntries();
		return size;
	}

	/**
	 * Xg̍ŌɁAw肳ꂽvfǉ܂B
	 * 
	 * @param e
	 *            Xgɒǉvf
	 * @return true
	 * @throws IllegalArgumentException
	 *             null̏ꍇ
	 */
	public boolean add(Object e) {
		if (e == null) {
			throw new IllegalArgumentException();
		}
		expungeStaleEntries();
		addBefore(e, root);
		return true;
	}

	/**
	 * w肳ꂽvf̃Xgɂ΁A̍ŏ̂̂Xg폜܂B
	 * 
	 * @param o
	 *            Xg폜vf
	 * @return 폜ꂽꍇtrue
	 */
	public boolean remove(Object o) {
		if (o != null) {
			expungeStaleEntries();

			Entry e = find(o);
			if (e != null) {
				remove(e);
				return true;
			}
		}
		return false;
	}

	/**
	 * Xg炷ׂĂ̗vf폜܂B
	 */
	public void clear() {
		for (Entry e = root.next; e != root;) {
			Entry next = e.next;
			remove(e);
			e = next;
		}
		root.next = root.prev = root;
		size = 0;
		modCount++;
	}

	//
	//
	//

	/**
	 * ̃Xg̗vfK؂ȏŌJԂ锽qԂ܂B
	 * 
	 * @return q
	 */
	public Iterator iterator() {
		expungeStaleEntries();
		return new Itr();
	}

	private class Itr implements Iterator {

		private Entry current = root.next, lastRet = null;

		private int expectedModCount = modCount;

		public boolean hasNext() {
			return current != root;
		}

		public Object next() {
			checkForComodification();
			lastRet = current;
			current = current.next;
			return lastRet.get();
		}

		public void remove() {
			if (lastRet == null) {
				throw new IllegalStateException();
			}
			checkForComodification();
			WeakList.this.remove(lastRet);
			lastRet = null;
			expectedModCount = modCount;
		}

		final void checkForComodification() {
			if (modCount != expectedModCount)
				throw new ConcurrentModificationException();
		}
	}

	/**
	 * ̃Xg̗vfK؂ȏŌJԂ郊XgqԂ܂B
	 * 
	 * @return Xgq
	 * @throws IndexOutOfBoundsException
	 *             CfbNX͈͊Ȍꍇ
	 */
	public ListIterator listIterator(int index) {
		// expungeStaleEntries();
		return new ListItr(index);
	}

	private class ListItr implements ListIterator {
		private Entry lastReturned = root;

		private Entry next;

		private int nextIndex;

		private int expectedModCount = modCount;

		ListItr(int index) {
			if (index < 0 || index > size) {
				throw new IndexOutOfBoundsException("Index: " + index
						+ ", Size: " + size);
			}
			if (index < size / 2) {
				next = root.next;
				for (nextIndex = 0; nextIndex < index; nextIndex++)
					next = next.next;
			} else {
				next = root;
				for (nextIndex = size; nextIndex > index; nextIndex--)
					next = next.prev;
			}
		}

		public boolean hasNext() {
			return nextIndex != size;
		}

		public Object next() {
			checkForComodification();
			if (nextIndex == size)
				throw new NoSuchElementException();

			lastReturned = next;
			next = next.next;
			nextIndex++;
			return lastReturned.get();
		}

		public boolean hasPrevious() {
			return nextIndex != 0;
		}

		public Object previous() {
			if (nextIndex == 0)
				throw new NoSuchElementException();

			lastReturned = next = next.prev;
			nextIndex--;
			checkForComodification();
			return lastReturned.get();
		}

		public int nextIndex() {
			return nextIndex;
		}

		public int previousIndex() {
			return nextIndex - 1;
		}

		public void remove() {
			checkForComodification();
			Entry lastNext = lastReturned.next;
			try {
				WeakList.this.remove(lastReturned);
			} catch (NoSuchElementException e) {
				throw new IllegalStateException();
			}
			if (next == lastReturned)
				next = lastNext;
			else
				nextIndex--;
			lastReturned = root;
			expectedModCount++;
		}

		public void set(Object e) {
			throw new UnsupportedOperationException();
		}

		public void add(Object e) {
			checkForComodification();
			lastReturned = root;
			addBefore(e, next);
			nextIndex++;
			expectedModCount++;
		}

		final void checkForComodification() {
			if (modCount != expectedModCount)
				throw new ConcurrentModificationException();
		}
	}

	//
	// Queue
	//

	/**
	 * ̃Xg̐擪 (ŏ̗vf) 擾܂B
	 * 
	 * @return Xg̍ŏ̗vfiGCƂ̃^C~OɂĂnull̏ꍇj<br>
	 *         Xg̏ꍇnull
	 */
	public Object peek() {
		expungeStaleEntries();
		if (size == 0) {
			return null;
		}
		return root.next.get();
	}

	/**
	 * ̃Xg̐擪 (ŏ̗vf) 擾܂B
	 * 
	 * @return Xg̍ŏ̗vfiGCƂ̃^C~OɂĂnull̏ꍇj
	 * @throws NoSuchElementException
	 *             Xg̏ꍇ
	 * @see #getFirst()
	 */
	public Object element() {
		return getFirst();
	}

	/**
	 * ̃Xg̐擪 (ŏ̗vf) 擾A폜܂B
	 * 
	 * @return Xg̍ŏ̗vfiGCƂ̃^C~OɂĂnull̏ꍇj<br>
	 *         Xg̏ꍇnull
	 */
	public Object poll() {
		expungeStaleEntries();
		if (size == 0)
			return null;
		return remove(root.next);
	}

	/**
	 * ̃Xg̐擪 (ŏ̗vf) 擾A폜܂B
	 * 
	 * @return Xg̍ŏ̗vfiGCƂ̃^C~OɂĂnull̏ꍇj
	 * @throws NoSuchElementException
	 *             Xg̏ꍇ
	 * @see #removeFirst()
	 */
	public Object remove() {
		return removeFirst();
	}

	/**
	 * w肳ꂽvf̃Xg̖ (Ō̗vf) ɒǉ܂B
	 * 
	 * @param e
	 *            ǉvf
	 * @throws IllegalArgumentException
	 *             null̏ꍇ
	 * @see #add(Object)
	 */
	public boolean offer(Object e) {
		return add(e);
	}

}
